/*----- PROTECTED REGION ID(SIKO_MA505Class.h) ENABLED START -----*/
//=============================================================================
//
// file :        SIKO_MA505Class.h
//
// description : Include for the SIKO_MA505Class root class.
//               This class is the singleton class for.
//               the SIKO_MA505 device class..
//               It contains all properties and methods which the .
//               SIKO_MA505 requires only once e.g. the commands.
//
// project :     SIKO MA505 Magnetic Encoder Display.
//
// $Author: borghes $
//
// $Revision: 1.1.1.1 $
// $Date: 2013-12-24 15:09:38 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/sikoma505/src/SIKO_MA505Class.h,v $
// $Log: SIKO_MA505Class.h,v $
// Revision 1.1.1.1  2013-12-24 15:09:38  borghes
// SIKO MA505 encoder display
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef SIKO_MA505CLASS_H
#define SIKO_MA505CLASS_H

#include <tango.h>
#include <SIKO_MA505.h>

/*----- PROTECTED REGION END -----*/

namespace SIKO_MA505_ns
{
	/*----- PROTECTED REGION ID(SIKO_MA505::classes for dynamic creation) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	SIKO_MA505::classes for dynamic creation



//=========================================
//	Define classes for attributes
//=========================================
//	Attribute Position class definition
class PositionAttrib: public Tango::Attr
{
public:
	PositionAttrib():Attr("Position",
	                   Tango::DEV_DOUBLE, Tango::READ) {};
	~PositionAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SIKO_MA505 *>(dev))->read_Position(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SIKO_MA505 *>(dev))->is_Position_allowed(ty);}
};





//=========================================
//	Define classes for commands
//=========================================




/**
 *	The TemplateDevServClass singleton definition
 */

class
#ifdef _TG_WINDOWS_
	__declspec(dllexport)
#endif
	SIKO_MA505Class : public Tango::DeviceClass
{
	/*----- PROTECTED REGION ID(SIKO_MA505::Additionnal DServer data members) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	SIKO_MA505::Additionnal DServer data members



public:
//	write class properties data members
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static SIKO_MA505Class *init(const char *);
	static SIKO_MA505Class *instance();
	~SIKO_MA505Class();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	SIKO_MA505Class(string &);
	static SIKO_MA505Class *_instance;
	void command_factory();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();
	void get_class_property();
	string get_cvstag();
	string get_cvsroot();

private:
	void device_factory(const Tango::DevVarStringArray *);
	void create_static_attribute_list(vector<Tango::Attr *> &);
	void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
	vector<string>	defaultAttList;


};

}	//	namespace

#endif	//	SIKO_MA505CLASS_H

